#!/usr/bin/perl

use strict;
use warnings;

use lib ('../');

use Test::More tests => 2;

use Logaholic::Log::Domlog;

# If this test fails, all log parsing will fail.
#
# This test was extracted from the general logline test when we had to re-work
# the regex  parsing to be compatible with Perl < 5.10.0; versions below that
# cannot do named captures.
{
    my $logformat_regex = Logaholic::Log::Domlog::get_logformat_regex('ApacheCombinedCookieLogParser');
    my $line            = qq(9.9.9.9 - - [16/Nov/2012:03:07:48 +0100] "GET /favicon.ico HTTP/1.1" 200 2550 "http://www.fqdn.tld/app/product_info.php/products_id/49" "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US) AppleWebKit/534.7 (KHTML, like Gecko) Chrome/7.0.517.44 Safari/534.7" "NewLogaholic_VID=55229429000; NewLogaholic_SESSION=49097730000");

    like(
        $line, $logformat_regex,
        'will properly match regex against regular line with referrer + agents + cookie'
    );
    my $nefarious_line = qq(9.9.9.9 - - [13/Aug/2012:22:15:59 +0200] "GET /app/product_info.php?products_id=35'\" HTTP/1.0" 200 37372 "-" "-" "-");
    unlike(
        $nefarious_line, $logformat_regex,
        'will properly not match regex against nefarious line with referrer + agents'
    );
}
