<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2012 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
// include_once logaholic_dir() ."/components/useragents/techpattern.php";
require_once logaholic_dir() ."/components/UASparser/UASparser.php";
$ua_parser = new UASparser();   
$ua_parser->SetCacheDir(logaholic_dir() ."files/"); 

class Import {
	var $logdir;
	var $print;
	var $log_parser;
	var $num_import_lines;
	
	function __construct() {
		global $profile;
		
		$this->print = 2;
		
		if (isset($profile)) {
			if (LOGAHOLIC_BASE_EDITION == "cPanel Edition") {
				$logdir = $profile->logfilefullpath;
			} else {
				if(getGlobalSetting("upload_dir") !== false && $profile->trackermode == 2) {
					$logdir = getGlobalSetting("upload_dir", logaholic_dir()."files/");
					$logdir .= "{$profile->profilename}/";
				} else {
					$logdir = $profile->logfilefullpath;
				}
			}
		} else {
			# we might want to use functions from this class even though we don't have a loaded profile
			$logdir = "";
		}
		
		$this->num_import_lines = 0;
		
		$this->logdir = $logdir;
		$this->totaltime = 0;
		$this->startscript = time();
		$this->manage_keys = false;
	}
	
	function setLogParser($format) {
		if (class_exists($format)) {
			$this->log_parser = new $format;
		} else {
			return false;
		}
	}
	
	function AvailableCheck() {
		# In this function we check if everything we need to do a perl update is available.
		
		global $mysqltmp;
		
		$return = array(
			'hasError' => false
		);
		
		# We don't support Windows machines.
		// if(strpos(strtolower($_SERVER['SERVER_SOFTWARE']), 'win32') !== false || strpos(strtolower($_SERVER['SERVER_SOFTWARE']), 'win64') !== false) {
		if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
			$return[] = _PERL_UPDATE_NOT_AVAILABLE_FOR_WINDOWS;
			$return['hasError'] = true;
			return $return;
		}
		
		# Let's check if Perl exists.
		$cmd = "prove -vl ".logaholic_dir()."components/import/preparse.t";
		exec($cmd, $output, $status);
		
		if ($status=="Result: PASS") {
			$return[] = implode("<br />\n",$output);
		} else {
			$return[] = implode("<br />\n",$output);
			$return['hasError'] = true;
		}
		//var_dump($output);
		
		/* this is the old stuff */
		/*
		$perl_script = logaholic_dir()."components/import/perlneeds.plx";
		
		# The command to run
		$cmd = "perl {$perl_script}";
		
		#Run the command
		exec($cmd, $output, $status);
		
		if(!empty($output)) {
			// $return[] = $output[0];
			unset($output);
		} else {
			$return[] = _PERL_NOT_INSTALLED_INSTALL_ACTIVEPERL;
			$return['hasError'] = true;
		}
		
		# Let's check if we have the Time::Local module.
		exec("perl -MTime::Local -e 1", $output, $status);
		
		if($status != 0) {
			$return[] = _TIME_LOCAL_PERL_MODULE_NOT_INSTALLED;
			$return['hasError'] = true;
		} else {
			// $return[] = _TIME_LOCAL_PERL_MODULE_INSTALLED;
		}
		
		# Let's check if we have the Digest::MD5 module.
		exec("perl -MDigest::MD5 -e 1", $output, $status);
		
		if($status != 0) {
			$return[] = _DIGEST_MD5_PERL_MODULE_NOT_INSTALLED;
			$return['hasError'] = true;
		} else {
			// $return[] = _DIGEST_MD5_PERL_MODULE_INSTALLED;
		}
		
		# Let's check if we have the PerlIO::gzip module.
		exec("perl -MPerlIO::gzip -e 1", $output, $status);
		
		if($status != 0) {
			$return[] = _PERLIO_GZIP_PERL_MODULE_NOT_INSTALLED;
			$return['hasError'] = true;
		} else {
			// $return[] = _PERLIO_GZIP_PERL_MODULE_INSTALLED;
		}
		
		# Let's check if we have the Geo::IP module.
		exec("perl -MGeo::IP -e 1", $output, $status);
		if($status != 0) {
			$return[] = _GEOIP_PERL_MODULE_NOT_INSTALLED;
			$return['hasError'] = true;
		} else {
			// $return[] = _GEOIP_PERL_MODULE_INSTALLED;
		}
		*/		
		
		# Let's check if the temporary files directory exists...
		if(is_dir($mysqltmp)) {
			# ... and if it's writable
			if(is_writable($mysqltmp)) {
				// $return[] = str_replace("%s", $mysqltmp, _MYSQLTMP_DIR_WRITABLE);
			} else {
				$return[] = str_replace("%s", $mysqltmp, _MYSQLTMP_DIR_NOT_WRITABLE);
				$return['hasError'] = true;
			}
		} else {
			$return[] = str_replace("%s", $mysqltmp, _MYSQLTMP_DIR_NONEXISTING);
			$return['hasError'] = true;
		}
		
		return $return;
	}
	
	function WriteConfigFile($config_file = '', $log_file = '', $new_log_file = '') {
		global $profile, $force, $skiptime;
		
		# The config file will be written in the /files/ directory, as {$profilename}_config
		
		# Important params should strip important param from the urlparams and refparams
		# Then, the removed part should be pasted to the corresponding url
		$important_params = '';
		$c = 0;
		foreach($profile->importantURLParams as $param) {
			if($c > 0) { $important_params .= ','; }
			$important_params .= $param['filename'].'::'.$param['importantparams'];
			$c++;
		}
		
		# Set time where to start parsing
		$skiptime = $this->getStartTimeForProfile();
		
		$fh = fopen($config_file, 'w+');
		set_permissions($config_file);
		
		# Set the input file (log file) and output file (preparsed log)
		fwrite($fh, "inputfile=".$log_file."\n");
		fwrite($fh, "outputfile=".$new_log_file."\n");
		
		# get the last log position
		$lastpos = getProfileData($profile->profilename, $profile->profilename.".lastlogpos.".md5($log_file), 0);
		$firstlogline = getProfileData($profile->profilename, $profile->profilename.".firstlogline.".md5($log_file), 0);
		
		# Set force, if needed
		if(isset($force) && $force == true) {
			fwrite($fh, "force=1\n");
		}
		
		$format = formatOfLogFile($log_file);
		fwrite($fh, "logformat=".$format['ClassName']."\n");
		
		# Set the visitorid method
		if ($profile->visitoridentmethod == VIDM_IPADDRESS) {
			$visitorid_method = 'VIDM_IPADDRESS';
		} else if ($profile->visitoridentmethod == VIDM_IPPLUSAGENT) {
			$visitorid_method = 'VIDM_IPPLUSAGENT';
		} else if ($profile->visitoridentmethod == VIDM_COOKIE) {
			$visitorid_method = 'VIDM_COOKIE';
		}
		
		# Add equivalent domains to the config file
		if(substr($profile->equivdomains, 0, 1) == '(') {
			$equivdomains = $profile->equivdomains;
		} else {
			$equivdomains = str_replace(" ", "", str_replace(",", "|", $profile->equivdomains));
			$equivdomains = explode("|", $equivdomains);
			foreach($equivdomains as $key => $val) {
				$equivdomains[$key] = '://'.$val;
			}
			$equivdomains = implode("|", $equivdomains);
		}
		
		$sessioncounter = $this->GetSessionCounter();
		
		# Write the settings to the config file
		fwrite($fh, "confdomain={$profile->confdomain}\n");
		fwrite($fh, "equivdomains=".$equivdomains."\n");
		fwrite($fh, "vidm={$visitorid_method}\n");
		fwrite($fh, "lastpos={$lastpos}\n");
		fwrite($fh, "firstlogline={$firstlogline}\n");
		fwrite($fh, "skiptime={$skiptime}\n");
		fwrite($fh, "googleparams=".str_replace(" ", "", str_replace(",", "|", $profile->googleparams))."\n");
		fwrite($fh, "skipfiles=".str_replace(" ", "", str_replace(",", "|", $profile->skipfiles))."\n");
		fwrite($fh, "skipips=".str_replace(" ", "", str_replace(",", "|", $profile->skipips))."\n");
		fwrite($fh, "importantparams={$important_params}\n");
		fwrite($fh, "urlparamfiltermode={$profile->urlparamfiltermode}\n");
		fwrite($fh, "urlparamfilter={$profile->urlparamfilter}\n");
		fwrite($fh, "sessioncounter={$sessioncounter}\n");
		
		fclose($fh);
	}
	
	# This function fetches the maximum timestamp from the data existing in the profile's main table and returns it.
	function getStartTimeForProfile() {
		global $profile, $db, $skiptime,$force;
		if (isset($skiptime)) {
			return $skiptime;
		}
		
		if($force === true){
			$skiptime = 0;
			return $skiptime;
		}		
		
		$q = $db->Execute("SELECT MAX(`timestamp`) FROM {$profile->tablename}");
		$skiptime = $q->FetchRow();
		if(!empty($skiptime[0])) {
			$skiptime = $skiptime[0];
		} else {
			$skiptime = 0;
		}
		
		return $skiptime;
	}
	
	# recursive loop through directory in search of files.
	function RecursivelySearchDir($dir, $dirs = array()){
		if(substr($dir, -1) == "/"){
			$dir = substr_replace($dir ,"",-1);
		}
		
		foreach(glob($dir . '/*') as $file) {
			if(is_dir($file) && $file !== '.' && $file !== '..'){
				$dirs[] = $file;
				$dirs = $this->RecursivelySearchDir($file, $dirs);
			}
		}
		return $dirs;
	}
	
	# Tis function reads a directory for log files and returns then in a array.
	function ReadDirectoryForLogs($directory){	
		global $profile, $skiptime, $force;
		
		$logfiles = array();
		$skiptime = $this->getStartTimeForProfile();
		
		# We open the directory
		$handle = opendir($directory);
		$ls = array();
		# While we have files in the directory...
		while ($file = readdir($handle)) {
				
			# ... we paste the directory and filename together ...
			if(substr($directory, -1) != "/") {
				$filename = $directory."/".$file;
			} else {
				$filename = $directory.$file;
			}
			
			# ... and get the filename and modification date for each file.
			if ($file[0] != '.') {
				clearstatcache();
				$rfn = "{$filename}";
				$mt = filemtime($rfn);
				
				# now lets see if we've already analyzed this file
				if($force === false){
					$lastmodtime = getProfileData($profile->profilename, $profile->profilename.".lastmodtime.".md5($filename), 0);
				} else {
					$lastmodtime = 0;
				}
				
				if ($lastmodtime == $mt) {
					# this file has probably been done, skip it
					continue;
				}
				
				$ls[$file] = $mt;
				
			}
		}
		
		if (!isset($ls)) {
			closedir($handle);
			return;
		}
		
		# Sort by filename
		asort($ls);		

		foreach($ls as $file => $modtime) {
			# If the modification time is lower than the start time of data, we are looking at an old log file; skip it.
			
			
			if(($skiptime - $modtime) > 86400) {
				continue;
			}
			
			# We did this already in the above code, but apparently, it's needed to do so again.
			if(substr($directory, -1) != "/") {
				$filename = $directory."/".$file;
			} else {
				$filename = $directory.$file;
			}
			
			if ($profile->splitfilternegative) {
				if (strpos($file, $profile->splitfilternegative) !== FALSE) {
					continue;
				}
			}
			
			if ($profile->splitfilter) {
				if (strpos($profile->splitfilter, '(') !== FALSE) {
					# we have a regex splitfilter
					if (preg_match("/".$profile->splitfilter."/i", $file)) {
						# it matched, so we want to analyze it
					} else {
						# It doesn't match; skip it.
						continue;
					}
				} else if (strpos($file, $profile->splitfilter) === FALSE) {
					continue;
				}
			}
			
			# In Perl, we can read both zipped files as non-zipped files.
			# However, the code below might be needed sometime again, so it's commented.
			if (substr($filename, -3, 3) == ".gz") {
				// // exec("gzip --stdout -d {$filename} > /tmp/lwa_{$file}.log;");
				// // $logfiles[] = "/tmp/lwa_{$file}.log";
				$logfiles[] = $filename;
			} else {
				$logfiles[] = $filename;
			}
			
		}
		return $logfiles;
	}
	
	# This function returns an array containing all full paths to each log file we need to parse.
	function GetLogFilesArray() {
		global $profile;
		
		$logfiles = array();
		
		# If we handle more than one log file
		if($profile->splitlogs == 1) {
			if($profile->recursive == 1){
				$dirs = $this->RecursivelySearchDir($this->logdir);
				
				$logfiles = $this->ReadDirectoryForLogs($this->logdir);
				foreach($dirs as $dir){
					$temparray = $this->ReadDirectoryForLogs($dir);
					if(empty($temparray)){
						continue;
					}
					
					foreach($temparray as $k => $v){
						$logfiles[] = $v;
					}
				}
				
			} else {
				$logfiles = $this->ReadDirectoryForLogs($this->logdir);
			}
		} else {
			# We only have one log file, so we return an array with 1 entry.
			$logfiles[] = $profile->logfilefullpath;
		}
		
		return $logfiles;
	}
	
	# This is where we load the preparsed log file into a temprary table.
	function ImportLog($file) {
		global $db, $profile, $log_parser_types, $skiptime;
		$start=time();
		
		$this->fsize = round(((filesize($file)/1024)/1024),2);
		if ($this->manage_keys === true) {
			$this->LogProcess("starting import with manage_keys ON");
		} else {
			$this->LogProcess("starting import with manage_keys off");
		}
		
		//$this->LogProcess(_IMPORTING_LOG_FILE_INTO_DATABASE." ($this->fsize mb) ...");
		
		# This function creates a mysql function for URL decoding.
		// mysql_urldecode();
		
		# If the log table already exists, delete it; we want a clean one.
		$db->Execute("DROP TABLE IF EXISTS {$profile->tablename}log");
		
		# Create the log table.
		$db->Execute("CREATE TABLE `{$profile->tablename}log` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `host` varchar(255) DEFAULT NULL,
			  `logname` varchar(45) DEFAULT NULL,
			  `user` varchar(45) DEFAULT NULL,
			  `timestamp` int(11) DEFAULT NULL,
			  `timezone` varchar(7) DEFAULT NULL,
			  `request` text DEFAULT NULL,
			  `status` varchar(4) DEFAULT NULL,
			  `bytes` varchar(10) DEFAULT NULL,
			  `referrer` text DEFAULT NULL,
			  `useragent` text DEFAULT NULL,
			  `useragent_hash` varchar(32) DEFAULT NULL,
			  `cookie` text DEFAULT NULL,
			  `urlparams` text DEFAULT NULL,
			  `refparams` text DEFAULT NULL,
			  `keywords` text DEFAULT NULL,
			  `visitorid` varchar(32) DEFAULT NULL,
			  `country` varchar(100) DEFAULT NULL,
			  `crawl` int(1) DEFAULT '0',
			  `sessionid` int(11) DEFAULT NULL,
			  PRIMARY KEY (`id`),
			  KEY `visitortime` (`visitorid`,`timestamp`)
			) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8
		");
		
		# Force the Logaholic Format Log Parser
		$log_format["ClassName"] = "LogaholicLogformatParser";
		$this->log_parser = new $log_format["ClassName"];
		$this->log_parser->Initialize($file);
	
		# Load the parser query...
		$import_query = $this->log_parser->ImportQuery($file);
		$import_query_local = $this->log_parser->ImportQuery($file,"LOCAL");
		
		if($import_query == false){
			$took = $this->took($start);
			$this->LogProcess("Failed importing records from the log file! File does not exists! ".$this->sec2time($took));
			$this->StopOrContinue();
			return;
		}
		
		# ... and run it!
		try {
			error_reporting(0); 
			if($db->Execute($import_query) === false){
				throw new Exception();
			} else {
				$this->num_import_lines = $db->Affected_Rows();
			}
			//error reporting
			if (LOGAHOLIC_VERSION_STATUS=="release") {  
				error_reporting(E_ALL & ~E_NOTICE);    
			} else {
				error_reporting(E_ALL);
			}
			
		} catch(Exception $e){
			# Try to load it again and now with LOAD DATA LOCAL INFILE
			//error_reporting(0); 
			error_reporting(E_ALL);
				
			// dump($import_query_local);
			// exit();
			if ($db->Execute($import_query_local) === false) {
				# fall back to a slower method that does not use LOAD DATA INFILE
				if (LOGAHOLIC_VERSION_STATUS=="release") {  
					error_reporting(E_ALL & ~E_NOTICE);    
				} else {
					error_reporting(E_ALL);
				}
				$this->ReadFileAndImport($file);
			} else {
				if (LOGAHOLIC_VERSION_STATUS=="release") {  
					error_reporting(E_ALL & ~E_NOTICE);    
				} else {
					error_reporting(E_ALL);
				}
				
				$this->num_import_lines = $db->Affected_Rows();
				
			}			
		}		
		
		# Do some Log parser clean up, if needed
		$this->log_parser->CleanUp();
		
		$took = $this->took($start);
			
		$this->LogProcess("Imported {$this->num_import_lines} records from the log file ($this->fsize mb) in ".$this->sec2time($took));
		
		$this->StopOrContinue();

	}
	
	#this is a fall-back method that is only used if load data infile does not work to read the lwa log file
	function ReadFileAndImport($file) {
		global $db, $profile, $warnonce;
		
		# warn the user
		$this->LogProcess("Mysql LOAD DATA INFILE statement failed! Falling back to importing the file line by line...");
		if (!isset($warnonce)) {
			echoWarning("Mysql LOAD DATA INFILE statement failed! Falling back to importing the file line by line...<br>Make sure your mysql is allowed to use this statement for much faster importing.");
			$warnonce=1;
		}
		//echo $file." (".filesize($file).")<br>";
		
		# let's turn off indexes so we get better insert speed
		$this->EnableKeys($profile->tablename."log", false);
		
		# prepare a query
		$insertstart = "INSERT into {$profile->tablename}log (`host`, logname, `user`, `timestamp`, timezone, request, `status`, bytes, referrer, useragent, useragent_hash, cookie, urlparams, refparams, keywords, visitorid, country, crawl, sessionid) values ";
		$insert = "";
		
		$n=0;
		$i=0;
		$fp = fopen($file, "r");
		while (($line = fgets($fp)) !== false) {
		
			$line = explode("|LWA|", $line);
			$insert .= "(";
			foreach ($line as $val) {
				$insert .= $db->Quote(trim($val)) . ", ";
			}
			$insert = substr($insert, 0, -2) . ")";
			$i++;
			
			# if we've saved up enough lines, insert it into the table
			if ($i >= 500) {
				$q = $insertstart . $insert;
				$db->Execute($q);
				$insert = "";
				$i=0;
				
			} else {
				# add a comma for the next set of values
				$insert .= ",\n";
				
			}
			$n++;
		}
		# insert any remaining lines, remove the last comma first
		if (!empty($insert)) {
			$insert = substr($insert, 0, -2);
			$q = $insertstart . $insert;
			$db->Execute($q);
		}
		
		$this->num_import_lines = $n;
		
		# turn on indexes
		$this->EnableKeys($profile->tablename."log", true);
	}
	
	# This inserts elements like urls and keywords into the subtables
	function insertIDs() {
		global $db, $profile;
		
		if ($this->num_import_lines < 1) {
			return;
		}
		
		$tables = $this->getTables();
		
		foreach ($tables as $t) {
			$start = time();
						
			# Skip visitorIDs
			if($t['table'] == $profile->tablename_visitorids) { continue; }
			
			//$rows = $this->NumRows($t['table']);
			
			# disable the keys to speed up the insert
			//$this->EnableKeys($t['table'], false);
			
			//6$this->LogProcess(_INSERTING_IDS_INTO_DATABASE."(".$t['table'].")...");
						
			# insert missing items
			//$db->Execute("INSERT IGNORE INTO {$t['table']} ({$t['field']}, `hash`) (SELECT DISTINCT {$t['sfield']}, MD5({$t['sfield']}) FROM `{$profile->tablename}log` AS s LEFT JOIN {$t['table']} AS u ON MD5({$t['sfield']}) = u.hash WHERE u.id IS NULL)");
			//Just do insert ignore, it's faster
			$select = "SELECT DISTINCT {$t['sfield']}, MD5({$t['sfield']}) FROM `{$profile->tablename}log` AS s";
			$db->Execute("INSERT IGNORE INTO {$t['table']} ({$t['field']}, `hash`) ($select)");
			//$this->LogProcess($select);
			//$this->EnableKeys($t['table'], true);
			
			# calculate how many we inserted
			//$rows = $this->NumRows($t['table']) - $rows;
			//$this->LogProcess("inserted $rows");
			$rows = $db->Affected_Rows();
			$took = $this->took($start);
			$this->LogProcess("Inserting $rows records in {$t['table']} took ".$this->sec2time($took));			
			$this->StopOrContinue();
		}		
	}
	
	# This inserts the visitorids into the visitors table
	function insertVisitorIDs() {
		global $db, $profile;
		$start = time();
		
		if ($this->num_import_lines < 1) {
			return;
		}
		
		//$this->LogProcess(_INSERTING_VISITORIDS."...");
		
		# Detect the visitorid identification method
		switch($profile->visitoridentmethod) {
			case VIDM_IPADDRESS:
				$selection_method = " MD5(s.host) ";
				
				break;
			case VIDM_IPPLUSAGENT:
				$selection_method = " MD5(CONCAT(s.host,':',s.useragent)) ";
				
				break;
			case VIDM_COOKIE:
				$selection_method = "IF(LOCATE('NewLogaholic_VID=', `cookie`), MD5(SUBSTRING_INDEX(SUBSTRING_INDEX(`cookie`, 'NewLogaholic_VID=', -1), ';', 1)), MD5(CONCAT(s.host,':',s.useragent)))";
				
				break;
		}
		
		# Insert the visitorid into the visitor ID's table
		$sql = "INSERT IGNORE INTO {$profile->tablename_visitorids} (`visitorid`, `ipnumber`, `created`) (SELECT DISTINCT {$selection_method} AS vid, s.host, MIN(s.`timestamp`) FROM `{$profile->tablename}log` AS s GROUP BY vid)";
		// dump($sql);
		// exit();
		$db->Execute($sql);
		//$this->EnableKeys($profile->tablename_visitorids, true);
		# calculate how many we inserted
		$rows = $db->Affected_Rows();
		$took = $this->took($start);
		$this->LogProcess("Inserting $rows records in $profile->tablename_visitorids took ".$this->sec2time($took));			
		$this->StopOrContinue();
	}
	
	function getTables() {
		global $profile, $took, $totaltime;
		
		# Get an array containing all needed tables for the current profile.
		$tables = array();
		$tables[] = array('table' => $profile->tablename_urls , 'field' => 'url', 'sfield' => 's.request');
		$tables[] = array('table' => $profile->tablename_urlparams , 'field' => 'params', 'sfield' => 's.urlparams');
		$tables[] = array('table' => $profile->tablename_referrers , 'field' => 'referrer', 'sfield' => 's.referrer');
		$tables[] = array('table' => $profile->tablename_refparams , 'field' => 'params', 'sfield' => 's.refparams');
		$tables[] = array('table' => $profile->tablename_keywords , 'field' => 'keywords', 'sfield' => 's.keywords');
		$tables[] = array('table' => $profile->tablename_useragents , 'field' => 'useragent', 'sfield' => 's.useragent');
		$tables[] = array('table' => $profile->tablename_visitorids , 'field' => 'visitorid', 'sfield' => "md5(CONCAT(s.host,':',s.useragent))");
		
		return $tables;
	}
	
	function insertNormalized() {
		global $profile, $db, $mysqltmp;
		
		if ($this->num_import_lines < 1) {
			return;
		}
		
		# Detect the visitorid identification method
		switch($profile->visitoridentmethod) {
			case VIDM_IPADDRESS:
				$selection_method = " MD5(log.host) ";
				
				break;
			case VIDM_IPPLUSAGENT:
				$selection_method = " MD5(CONCAT(log.host,':',log.useragent)) ";
				
				break;
			case VIDM_COOKIE:
				$selection_method = "IF(LOCATE('NewLogaholic_VID=', `cookie`), MD5(SUBSTRING_INDEX(SUBSTRING_INDEX(`cookie`, 'NewLogaholic_VID=', -1), ';', 1)), MD5(CONCAT(log.host,':',log.useragent)))";
				
				break;
		}
		
		$start = time();

		# Insert all ID's into the profile's main table, from all other tables.
		$q  = "INSERT INTO {$profile->tablename} (timestamp, visitorid, url, params, status, bytes, country, crawl, sessionid, referrer, refparams, useragentid, keywords) ";
		$q .= "SELECT `timestamp`, v.id, u.id, up.id, status, bytes, country, log.crawl, sessionid, r.id, rp.id, ua.id, k.id FROM `{$profile->tablename}log` AS log, "; 
		$q .= "{$profile->tablename_visitorids} as v,";
		$q .= "{$profile->tablename_urls} as u,";
		$q .= "{$profile->tablename_urlparams} as up,";
		$q .= "{$profile->tablename_referrers} as r,";
		$q .= "{$profile->tablename_refparams} as rp,";
		$q .= "{$profile->tablename_keywords} as k,";
		$q .= "{$profile->tablename_useragents} as ua ";
		$q .= "WHERE $selection_method = v.visitorid AND "; 
		$q .= "MD5(log.request) = u.hash AND MD5(log.urlparams) = up.hash AND ";
		$q .= "MD5(log.referrer) = r.hash AND MD5(log.refparams) = rp.hash AND ";
		$q .= "MD5(log.keywords) = k.hash AND MD5(log.useragent) = ua.hash ";
		//$q .= "INTO OUTFILE '{$mysqltmp}/{$profile->tablename}.normalized'";
		$db->Execute($q);		
		//$db->Execute("LOAD DATA INFILE '{$mysqltmp}/{$profile->tablename}.normalized' INTO TABLE {$profile->tablename}");
		
		$rows = $db->Affected_Rows();
		$took = $this->took($start);
		$this->LogProcess("Inserting $rows records in $profile->tablename took ".$this->sec2time($took));					
		
		$this->StopOrContinue();
	}
	
	# This will turns all non-unique mysql indexes off for the table. It makes inserting a lot of rows faster.
	function EnableKeys($table, $enable) {
		global $db;
		if ($this->manage_keys===false) {
			return;
		}
		if (!isset($enable)) {
			return;
		}		
		if ($enable==true) {
			$start = time();
			# enable keys when we are done inserting
			$db->Execute("ALTER TABLE {$table} ENABLE KEYS");
			$took = time() - $start;
			$this->LogProcess("Enabling index on $table took {$took}");
		} else {
			# disable the keys to speed up the insert
			$db->Execute("ALTER TABLE {$table} DISABLE KEYS");
		}	
	}
	
	function separateBots() {
		global $db, $profile;
		$start = time();
		$db->Execute("create table if not exists $profile->tablename_crawl like $profile->tablename");
		
		$db->Execute("UPDATE {$profile->tablename},{$profile->tablename_useragents} SET {$profile->tablename}.crawl = 1 WHERE {$profile->tablename}.useragentid = {$profile->tablename_useragents}.id AND {$profile->tablename_useragents}.is_bot = 1");
		
		# find visitorids that the user has marked as a bot
		$q = $db->Execute("select id from $profile->tablename_visitorids where crawl=1");
		$ids = array();
		while ($data = $q->FetchRow()) {
			$ids[] = $data['id'];
		}
		if (count($ids) > 0) {
			$ids = implode(",",$ids);
			$db->Execute("update $profile->tablename set crawl=1 where visitorid IN ($ids)");
		}
		# find feed urls and update to crawl=2
		if ($profile->feedurl!="") {
			$q = $db->Execute("select id from $profile->tablename_urls where url like '$profile->feedurl%'");
			$ids = array();
			while ($data = $q->FetchRow()) {
				$ids[] = $data['id'];
			}
			if (count($ids) > 0) {
				$ids = implode(",",$ids);
				$db->Execute("update $profile->tablename set crawl=2 where url IN ($ids)");
			}
		}
		
		# now move all the crawler hits to the crawl table and delete them from the main table
		$db->Execute("insert into $profile->tablename_crawl select * from $profile->tablename where crawl != 0");
		$db->Execute("delete from $profile->tablename where crawl!=0");
		$took = $this->took($start);			
		$this->LogProcess("Moving bots to crawl table took ".$this->sec2time($took));		
	}
	
	function copyConversions() {
		global $db, $profile;
		$start = time();
		# we want to move conversion urls to their own table for speedy access later
		if ($profile->targetfiles!="") { 
			//first figure out the dates			
			//we can get the to and from from the temp log table :)
			$range = GetMaxDateRange($profile, true);
			$from = $range['from'];
			$to = $range['to'];
			$targets = $profile->GetTargetIDs();
			if (!empty($to) && !empty($from) && is_array($targets) && count($targets)) {
				$db->Execute("delete from $profile->tablename_conversions where timestamp >=$from and timestamp <=$to") or die($db->ErrorMsg());
				$db->Execute("insert into $profile->tablename_conversions select timestamp,visitorid,url from $profile->tablename where timestamp between $from and $to and url in (".implode(",",$targets).") and (status=200 or status=302) order by timestamp")  or die("Error updating conversion stats. ".$db->ErrorMsg());
				$took = $this->took($start);			
				$this->LogProcess("Moving conversions to table took ".$this->sec2time($took));
			}
		}		
	}
	
	
	function thisTook($start, $update_total = true) {		
		
		$took = $this->took($start);
		
		$tot="";
		if ($update_total == true) {
			$this->totaltime = $this->took($this->startscript);
			$tot_dur = $this->sec2time($this->totaltime);
			$tot = ". Total processing time is now {$tot_dur}";
		}		
		$duration = $this->sec2time($took);
				
		$this->LogProcess("This took $duration $tot", false);
		
		return time();
	}
	
	# this calculates how many seconds have passed since the start time
	function took($start) {				
		return time() - $start;		
	}
	
	# This converts a number of seconds to a pretty hours, minutes, seconds string
	function sec2time($secs) {
		$hours = str_pad(floor($secs / (60 * 60)),2,'0',STR_PAD_LEFT);
		$divisor_for_minutes = $secs % (60 * 60);
		$minutes = str_pad(floor($divisor_for_minutes / 60),2,'0',STR_PAD_LEFT);
		$divisor_for_seconds = $divisor_for_minutes % 60;
		$seconds = str_pad(ceil($divisor_for_seconds),2,'0',STR_PAD_LEFT);
		return "{$hours}:{$minutes}:{$seconds} ($secs secs)";
	}
	
	# This function prints stuff to the update progress log.
	function LogProcess($message, $include_took = false) {
		global $profile, $updatelog, $took, $totaltime, $human_readable_file;
		
		# If the message that will be returned starts with [Finished], we want to prepend this to the message, and remove it from the message.
		# This is so we then can detect it in the ajax request that reads the update progress log.
		if(substr($message, 0, 10) == '[Finished]') {
			$message = "[Finished]".$human_readable_file.": ".str_replace("[Finished]", "", $message);
		} else {
			$message = $human_readable_file.": ".$message;
		}
		
		# Write the line to the update progress log.
		if($this->print == 1){
			echo $message."<br/>";
		}
		if($this->print == 2){
			@fwrite($updatelog, $message."\n");
		}
		
		lgflush();			
		
	}
	
	# This function prints stuff to the log we use to analyze the spped of this fucker.
	function LogDuration($label, $speed, $secs) {
		global $profile, $human_readable_file;
		if (!isset($this->durationlog)) {
			$this->durationlog = fopen($profile->datamanagerDir.$profile->profilename."/{$profile->profilename}_update_duration.lwa.log", "a+");
			set_permissions($profile->datamanagerDir.$profile->profilename."/{$profile->profilename}_update_duration.lwa.log");
		}
		$message = $human_readable_file.", MB:,".@$this->fsize.", lines:,".@$this->num_import_lines.", ".$label.", Speed:,".floor($speed).", Seconds:,".$secs;
		# Write the line to the update duration log.
		fwrite($this->durationlog, $message."\n");	
		
	}	
	
	# This function will stop the update process if a user has remotely turned on the stop flag (via UI)
	function StopOrContinue() {
		global $profile;
		if (getProfileData($profile->profilename, "{$profile->profilename}.stop_update", false) == 1) {
			$this->LogProcess("Error: user stopped process", false);
			# reset the stop flag
			setProfileData($profile->profilename, "{$profile->profilename}.stop_update", false);
			# We are done with Perl update; unflag it.
			setProfileData($profile->profilename, "{$profile->profilename}.update_running", 'no');			
			die();
		} else {
			return true;
		}
	}
	
	# This function sets the corrected profile table name for this update job.
	# we need this when we are using merge tables
	function correctProfileTablename() {
		global $db, $profile;
		
		if (isset($this->real_profile_tablename)) {
			$profile->tablename = $this->real_profile_tablename;
			return;
		}
				
		$query  = "SHOW CREATE TABLE $profile->tablename";
		$q= $db->Execute($query);
		if ($data = $q->FetchRow()) {
			$createtable = $data['Create Table'];
			if (strpos($createtable,"UNION")!==false) {
				$this->real_profile_tablename = $profile->tablename;
				$profile->tablename = $profile->tablename."_current";
			}
		} else {
			echoDebug("error for query: $query");
			return false;  
		}
			
	}

	function PHPanalyzeLine($logline){ 
		global $profile, $sessions, $sessioncounter, $geo, $gi, $mysqltmp, $bandwidth, $force;
		
		# Global the regexes, since we don't need to create a regex everytime.
		global $skiptime, $regex_skipips, $regex_skipfiles, $regex_urlparamfilter, $regex_equivdomains, $regex_googleparams;
		
		# Prepare the important params
		$dynamic_pages = array();
		foreach($profile->importantURLParams as $param) {
			$dynamic_pages[$param['filename']] = $param['importantparams'];
		}
		
		# Remove linebreaks from $urlparamfiltermode
		if(isset($urlparamfiltermode)) {
			$urlparamfiltermode = str_replace("\n", "", $urlparamfiltermode);
		}
		
		# If the line can not be parsed, skip it.
		if (!$this->log_parser->ParseLine($logline)) {
			return false;
		}
		
		# If the last line is not data, skip it.
		if ($this->log_parser->lastlineisdata === false) {
			return false;
		}
		
		if(empty($this->log_parser->clientip)) {
			return false;
		}
		
		# Name the parse line stuff
		$ipnumber = $this->log_parser->clientip;
		$url = $this->log_parser->reqfile;
		
		$logtimestamp = $this->log_parser->logdate;
		
		# Skip Files
		if(!empty($regex_skipfiles)) {
			if(preg_match("/({$regex_skipfiles})/i", $url) > 0) {
				return false;
			}
		}
		
		# Skip Time
		if($force==false) {
			if($logtimestamp <= $skiptime) {
				return false;
			}
		}
		
		# Skip Ipnumbers
		if(!empty($regex_skipips)) {
			if(preg_match("/({$regex_skipips})/i", $ipnumber) > 0) {
				return false;
			}
		}
		
		# Count the bandwidth
		$this->countBandwidth($this->log_parser->bytes, $this->log_parser->logdate);
		
		# URL Stuff
		if(strpos($url, '?') > -1) {
			$urlparams = substr($url, strpos($url, '?'));
			$url = substr($url, 0, strpos($url, '?'));
			
			# Here we strip the important parameters from the urlparams, and put it into url
			while (list($key, $value) = each($dynamic_pages)) {
				if($key == $url && strpos($urlparams, $value.'=') > -1) {
					$urlparam_part = substr($urlparams, strpos($urlparams, $value.'='));
					if(strpos($urlparam_part, '&') > -1) {
						$urlparam_part = substr($urlparams, strpos($urlparams, '&'));
					}
					
					$urlparams = preg_replace("/\?/i", "", $urlparams);
					$urlparams = preg_replace("/({$urlparam_part})/i", "", $urlparams);
					
					$url = $url.'?'.$urlparam_part;
				}
			}
			
			if(isset($urlparamfilter) && isset($urlparams) && preg_match("/({$regex_urlparamfilter})/i", $urlparams) > 0) {
				$urlparams = '';
			}
		} else {
			$urlparams = '';
		}
		
		# Determine the visitorid
		if ($profile->visitoridentmethod == VIDM_IPADDRESS) {
			$visitorid = md5($ipnumber);
		} else if ($profile->visitoridentmethod == VIDM_IPPLUSAGENT) {
			$visitorid = md5($ipnumber . ':' . $this->log_parser->agent);
		} else if ($profile->visitoridentmethod == VIDM_COOKIE) {
			# if we have a cookie, use it, else use VIDM_IPPLUSAGENT
			$cookies = $this->log_parser->cookie.";";
			$thisLogaholic_VID = strpos($cookies, "Logaholic_VID");
			if ($thisLogaholic_VID !== FALSE) {
				$thisLogaholic_VID = substr($cookies, $thisLogaholic_VID);
				$thisLogaholic_VID = substr($thisLogaholic_VID, 14, strpos($thisLogaholic_VID, ";") - 14);
				
				if (is_numeric($thisLogaholic_VID) == false) {
					$thisLogaholic_VID = md5($ipnumber . ':' . $this->log_parser->agent);
				}
				
				$visitorid = $thisLogaholic_VID;
				
				if (isset($debug) && $debug) {
					echo "we are using visitorid: $thisLogaholic_VID for $ipnumber<br>";
					echo "a new logaholic vid would look like this:".md5($ipnumber . ':' . $this->log_parser->agent);
					echo "<br>that is based on :".$ipnumber . ':' . $this->log_parser->agent;
					echo "<br>this is the cookie string :" . $cookies;
				}
			} else {
				$visitorid = md5($ipnumber . ':' . $this->log_parser->agent);
			}
		}
		
		# Parse Referrer Parameters (refparams) and keywords
		$keywords = "";
		$confdomain = $profile->confdomain;
		
		$referrer = $this->log_parser->referrer;
		
		
		# If empty referrer set referrer to '-' like in the old update
		if ($referrer == "") { $referrer = "-"; }
		
		if(!empty($regex_equivdomains)) {
			if(substr($profile->equivdomains, 0, 1) == '(') {
				$referrer = preg_replace("/({$regex_equivdomains})/i", $confdomain, $referrer);
			} else {
				$referrer = preg_replace("/({$regex_equivdomains})/i", "://".$confdomain, $referrer);
			}
		}
		
		if(strpos($referrer, '?') > -1) {
			$refparams = substr($referrer, strpos($referrer, '?'));
			$referrer = substr($referrer, 0, strpos($referrer, '?'));
			
			if(!isset($refparams)) {
				$refparams = '';
			}
			
			if(!empty($regex_urlparamfilter)) {
				$refparams = preg_replace("/({$regex_urlparamfilter})/i", "", $refparams);
			}
			# Here we strip the important parameters from the urlparams, and put it into url
			while (list($key, $value) = each($dynamic_pages)) {
				if($confdomain.$key == $referrer && strpos($refparams, $value.'=') > -1) {
					$refparam_part = substr($refparams, strpos($refparams, $value.'='));
					if(strpos($refparam_part, '&') > -1) {
						$refparam_part = substr($refparams, strpos($refparams, '&'));
					}
					
					$refparams = preg_replace("/\?/i", "//", $refparams);
					$refparams = preg_replace("/({$refparam_part})/i", "//", $refparams);
					
					$referrer = $referrer.'?'.$refparam_part;
				}
			}
			
			$keyworddetectors = array('as_q', 'as_epq', 'as_oq', 'as_eq', 'as_sitesearch', 'as_rq', 'as_lq');
			
			# If the referrer is google, we look at our predefined 'keyworddetectors'
			if(strpos($referrer, "www.google") > -1) {
				for($i = 0; $i < (count($keyworddetectors) - 1); $i++) {
					if(strpos($refparams, $keyworddetectors[$i]) > -1) {
						$keywordpart = substr($refparams, (strpos($refparams, $keyworddetectors[$i]) + strlen($keyworddetectors[$i])));
						if(strpos($keywordpart, '&') > -1) {
							$keywords = substr($keywordpart, 0, strpos($keywordpart, "&"));
						} else {
							$keywords = $keywordpart;
						}
					}
				}
				
				# Google Params
				# For each parameter in googleparams, remove it from refparams
				if(preg_match("/({$regex_googleparams})/i", $refparams) > 0) {
					$tmp = explode('&', $refparams);
					$stripped_params = array();
					$c = 0;
					
					for($i = 0; $i < (count($tmp) - 1); $i++) {
						$tmp_param = explode('=', $tmp[$i]);
						if(!empty($tmp_param[0])) {
							if(strpos($regex_googleparams, $tmp_param[0]) > -1) {
								$stripped_params[$c] = $tmp_param[0].'='.$tmp_param[1];
								$c++;
							}
						}
					}
					
					if(!empty($stripped_params)) {
						$refparams = implode("&", $stripped_params);
					}
				}
			}
			
			# If the referrer is yahoo, we look for ?p= or &p=
			if(strpos($referrer, "search.yahoo") > -1) {
				$keywordpart = substr($refparams, (strpos($refparams, "p=") + 2));
				if(strpos($keywordpart, '&') > -1) {
					$keywords = substr($keywordpart, 0, strpos($keywordpart, "&"));
				} else {
					$keywords = $keywordpart;
				}
			}
			
			# If it's not google, nor yahoo, we look for ?q= or &q=
			if(strpos($refparams, 'q=') > -1 && $keywords == "") {
				$keywordpart = substr($refparams, (strpos($refparams, 'q=') + 2));
				if(strpos($keywordpart, '&') > -1) {
					$keywords = substr($keywordpart, 0, strpos($keywordpart, "&"));
				} else {
					$keywords = $keywordpart;
				}
			}
			
			# If the referrer is google, but we haven't found a keyword, we'll set the keyword to 'Not Provided'
			if(strpos($referrer, "www.google") !== false && $keywords == "") {
				$keywords = "(Not Provided)";
			}
		} else {
			# There are no referrer parameters
			$refparams = '';
		}
		
		$session_timeout = ($profile->visittimeout * 60);
		
		// if(strpos($this->log_parser->agent,'whak') !== false){
			// continue;
		// }
		
		# Calculate sessions
		if(isset($sessions[$visitorid])) {
			if($logtimestamp - $sessions[$visitorid][1] > $session_timeout) {
				$sessions[$visitorid][1] = $logtimestamp;
				$sessions[$visitorid][2] = $sessioncounter++;
		
				# Set crawl
				if(preg_match("/(bot|spider|crawl|slurp)/i", $this->log_parser->agent) > 0) {
					
					$sessions[$visitorid][4] = 1;
				} else {			
					
					$sessions[$visitorid][4] = 0;
				}
			} else {
				# Add to visit
				$sessions[$visitorid][1] = $logtimestamp;
			}
		} else {
			$sessions[$visitorid][1] = $logtimestamp;
			$sessions[$visitorid][2] = $sessioncounter++;
			
			# Set crawl
			if(preg_match("/(bot|spider|crawl|slurp)/i", $this->log_parser->agent) > 0) {
				
				$sessions[$visitorid][4] = 1;
			} else {			
				
				$sessions[$visitorid][4] = 0;
			}
		}
		
		if ($geo) {
			if (!isset($sessions[$visitorid][3])) {
				$sessions[$visitorid][3] = geoip_country_code_by_addr_raw($gi, $ipnumber);
				//echoWarning($visitorid." ".$sessions[$visitorid][3]);
			}
		} else {
			$sessions[$visitorid][3] = "";
		}
		
		# Clean up the sessions array, to prevent we run out of memory
		if (memory_get_usage() > $this->totmem) {
			$prebyte = memory_get_usage();
			# just unset the ones that have expired
			$cses = 0;
			
			while (list ($key, $val) = each ($sessions)) {
				$time_elapsed = $logtimestamp - $val[1];
				if ($time_elapsed < $session_timeout) {
					$tempsessions[$key][0] = $val[0];
					$tempsessions[$key][1] = $val[1];
					$tempsessions[$key][2] = $val[2];
					$tempsessions[$key][3] = @$val[3];
					$tempsessions[$key][4] = $val[4];
					$tempsessions[$key][5] = $val[5];
					$cses++;
				}
			}
			
			$rses = $sesmem - $cses;
			$sesmem = $cses;
			
			$sessions = $tempsessions;
			unset($tempsessions);
		} else if (memory_get_usage() == 0) { # this is the case when we don't have the memory_get_usage function at all 
			if (count($sessions) > 2000) {
				#just unset the ones that have expired
				$cses = 0;
				while (list ($key, $val) = each ($sessions)) {
					$time_elapsed = $logtimestamp - $val[1];
					if ($time_elapsed < $session_timeout) {
						$tempsessions[$key][0] = $val[0];
						$tempsessions[$key][1] = $val[1];
						$tempsessions[$key][2] = $val[2];
						$tempsessions[$key][3] = $val[3];
						$cses++;
					}
				}
				
				$rses = $sesmem - $cses;
				$sesmem = $cses;
				
				$sessions = $tempsessions;
				unset($tempsessions);
			}
		}
		
		# Make sure the keywords are strtolower before entering the database.
		$keywords = urldecode($keywords);
		$keywords = strtolower($keywords);
		
		return strip_tags(implode("|LWA|", array(
			$ipnumber,
			'-',
			$this->log_parser->authuser,
			$logtimestamp,
			'-',
			$url,
			$this->log_parser->status,
			$this->log_parser->bytes,
			$referrer,
			$this->log_parser->agent,
			md5($this->log_parser->agent),
			$this->log_parser->cookie,
			$urlparams,
			urldecode($refparams),
			$keywords,
			$visitorid,
			$sessions[$visitorid][3],
			$sessions[$visitorid][4],
			$sessions[$visitorid][2]."\n")));
			
	}
	
	function GetSessionCounter() {
		global $profile, $db;
		
		$sessioncounter=getProfileData($profile->profilename, "$profile->profilename.sessioncounter", 0);
		// if sessioncounter is 0, we need to get the higest number from the db and store it (this should only happen once)
		if ($sessioncounter==0) {
			$sq = $db->Execute("select max(sessionid) scount from $profile->tablename");
			$sqd = $sq->FetchRow();
			$sessioncounter=$sqd['scount'];
		}
		return $sessioncounter;
	}
	
	function countBandwidth($bytes, $date) {
		global $bandwidth;
		
		$bytes = intval($bytes);
		$d = date("Y-m-d", $date);
		
		if(isset($bandwidth[$d])) {
			$bandwidth[$d] = $bandwidth[$d] + $bytes; 
		} else {
			$bandwidth[$d] = $bytes;
		}
	}
	
	function StoreBandwidth($bandwidth){
		global $profile;
		
		$report = New Report();
		
		$dir_1 = $profile->datamanagerDir.$profile->profilename;
		$dir_2 = $dir_1 ."/reports";
		
		$report->MakeDataDir($dir_1);
		$report->MakeDataDir($dir_2);
		
		foreach($bandwidth as $date => $bytes){
			$dateparts = explode("-",$date);
			
			$dir_3 = $dir_2 ."/". $dateparts[0];
			$dir_4 = $dir_3 ."/_BANDWIDTH";
				
			$report->MakeDataDir($dir_3);
			$report->MakeDataDir($dir_4);			
			$path = $dir_4;
			
			$ym = $dateparts[0] . $dateparts[1];
			
			$filename = "$path/_BANDWIDTH.{$ym}.gz";
			
			$old_data = array();
			
			if(file_exists($filename)){
				# File already exists get data and add new
				$old_data = $report->getDataFromFile($filename);
				unlink($filename);
			}
			
			$fp = gzopen($filename,"w");
			
			$row = array();
			
			if(!empty($old_data)){
				foreach($old_data as $k => $preRow){
					$row[0] = $preRow[0];
					
					if($preRow[0] == $date){ 
						$row[1] = $preRow[1] + $bytes;
					} else {
						$row[1] = $preRow[1];
					}
					
					gzwrite($fp,serialize($row)."\n");				
				}
			}
			
			$row[0] = $date;
			$row[1] = $bytes;
			gzwrite($fp,serialize($row)."\n");
			
			gzclose($fp);
			set_permissions($filename);
		}		
	}

	function Get_seektime() {
		global $db, $profile;
		$q = $db->Execute("select max(timestamp) from $profile->tablename");
		$data = $q->FetchRow();
		return $data[0];
	}
	
	function UpdateInternalReferrers(){
		global $db, $profile;
		$db->Execute("UPDATE {$profile->tablename_referrers} SET internal_referrer = 1 WHERE internal_referrer = 0 AND (referrer LIKE 'http://{$profile->confdomain}%' OR referrer LIKE 'https://{$profile->confdomain}%')");		
	}
	
	function DeviceCheck($ua){
		if(stripos($ua, 'ipad') !== false){
			return 'iPad';
		}
		if(stripos($ua, 'iphone') !== false){
			return 'iPhone';
		}
		if(stripos($ua, 'blackberry') !== false){
			return 'BlackBerry';
		}
		if(stripos($ua, 'samsung-') !== false){
			$dev = explode("/",$ua);
			return str_replace("-"," ",$dev[0]);
		}
		if(stripos($ua, 'sonyericsson') !== false){
			$dev = explode("/",$ua);
			return $dev[0];
		}
		if(stripos($ua, 'lg-') !== false){
			$dev = explode("/",$ua);
			return str_replace("-"," ",$dev[0]);
		}
		if(stripos($ua, 'playstation') !== false){
			return 'Playstation';
		}
		return "";
	}
	
	function UpdateUseragents() {
		global $db, $profile,$ua_parser;
		$useragent_time = time();		  
		
		$q = $db->Execute("SELECT * FROM {$profile->tablename_useragents} WHERE name IS NULL");
		while($row = $q->FetchRow()) {
			# Gets information about the current browser's user agent   
			$parsed = $ua_parser->Parse($row['useragent']);		  
			$agent['agent_name'] = $parsed['ua_family'];
			$agent['agent_version'] = ($parsed['ua_version'] == 'unknown') ? '' : $parsed['ua_version'];
			$agent['agent_os'] = $parsed['os_family'];
			$agent['agent_os_version'] = ($parsed['os_name'] == 'unknown') ? '' : $parsed['os_name'];
			$agent['agent_engine'] = '';
			
			$agent['agent_is_bot'] = 0;
			if(stripos($parsed['typ'],'browser') === false || $parsed['typ'] == 'Offline Browser') {
				$agent['agent_is_bot'] = 1;
			}
			if($parsed['typ'] == 'Multimedia Player'){
				$agent['agent_is_bot'] = 0;
			}
			
			$agent['agent_is_mobile'] = 0;
			if(stripos($parsed['typ'],'Mobile') !== false){
				$agent['agent_is_mobile'] = 1;
			}
			if($parsed['os_family'] == "Android" || $parsed['os_family'] == "Symbian OS"){
				$agent['agent_is_mobile'] = 1;
			}		
			
			
			$agent['agent_device'] = ($agent['agent_is_mobile'] == 0) ? '' : $this->DeviceCheck($row['useragent']);
			
			if($agent['agent_is_bot'] == 1) {
				$crawl = 1;
				$db->Execute("UPDATE {$profile->tablename} SET crawl = 1 WHERE useragentid = {$row['id']}");
			} else {
				$crawl = 0;
			}
			
			if($agent['agent_is_mobile'] == 1) {
				$ismobile = 1;
			} else {
				$ismobile = 0;
			}
			
			# Prepare the query to prevent MySQL Injection attacks
			$stmt = $db->Prepare("UPDATE {$profile->tablename_useragents} SET 
				`name` = ?,
				`version` = ?,
				`os` = ?,
				`os_version` = ?,
				`engine` = ?,
				`hash` = ?,
				`is_bot` = ?,
				`is_mobile` = ?,
				`device` = ?
			WHERE hash = '".$row['hash']."'");
			
			$db->Execute($stmt, array(
				$agent['agent_name'],
				$agent['agent_version'],
				$agent['agent_os'],
				$agent['agent_os_version'],
				$agent['agent_engine'],
				$row['hash'],
				$agent['agent_is_bot'],
				$agent['agent_is_mobile'],
				$agent['agent_device']
			));
		}
	}
}
?>