<?php

function HandleInputArguments(){
	global $conf, $running_from_command_line, $argv, $argc, $page, $force, $movedone, $debug, $delfile;
	$conf = @$_REQUEST["conf"]; 
	
	if (@!$running_from_command_line) {
		$running_from_command_line = false;
	}
	
	# In case we do a simple command line options of profilename 
	if (!$conf) {
		if (@isset($argv[1])) {
			if ($argv[1] == "running_from_command_line") {
				$conf = $argv[2];
			} else {
				if (strpos($argv[1],"=") !== FALSE) {
					# If we've passed in a command line, push it into the $_GET section this mean we can support name=value pairs as command line options
					if (@$argc > 0) {
						for ($i = 1; $i < $argc; $i++) {
							parse_str($argv[$i], $tmp);
							$_REQUEST = array_merge($_REQUEST, $tmp);
						}
						$running_from_command_line = @$_REQUEST["running_from_command_line"];
						$conf = @$_REQUEST["conf"];
						if (@!$running_from_command_line) {
							$running_from_command_line = true;
						}
					}
				} else {
					$conf = $argv[1];
				}
			}
			$running_from_command_line = true;
		} else {
			# attempt to read piped input
			$stdin_stream = fopen('php://stdin', 'r');
			if (is_resource($stdin_stream)) {
				stream_set_blocking($stdin_stream, 0); # should be necessary, but just in case
				if ($line = fgets($stdin_stream, 1024)) {
					parse_str(trim($line), $tmp);
					$_REQUEST = array_merge($_REQUEST, $tmp);
					$running_from_command_line = true;
				}
				fclose($stdin_stream); # shouldn't be necessary, but we'll do it anyway
			}
		}
	}

	$page = @$_REQUEST["page"]; # see security check below

	if (@$_REQUEST["force"]) {
		$force = true;
		# if force is true, it still does not redo the summay tables, we have to think of something for that (maybe just delete the summary tables ?, or remember the 'oldest' that gets inserted into the database (is it worth the effort ?)?)
	} else {
		$force = false;
	}

	if (@$_REQUEST["movedone"]) {
		$movedone = true;		
	} else {
		$movedone = false;
	}
	
	# if delfile is true, the original log file will be deleted after it's been processed
	if (isset($_REQUEST["delfile"]) && $_REQUEST["delfile"]==true) {
		$delfile = true;
	} else {
		$delfile = false;
	}
	
	$debug = "";
	if (@$_REQUEST["debug"]) {
		$debug = $_REQUEST["debug"];
	}
}


function OverrideOptions() {
	global $profile;

	if (isset($_REQUEST['logfilefullpath'])) {
		$profile->logfilefullpath = $_REQUEST['logfilefullpath'];
	}
	if (isset($_REQUEST['splitlogs'])) {
		$profile->splitlogs = $_REQUEST['splitlogs'];
	}
	if (isset($_REQUEST['recursive'])) {
		$profile->recursive = $_REQUEST['recursive'];
	}
	if (isset($_REQUEST['splitfilter'])) {
		$profile->splitfilter = $_REQUEST['splitfilter'];
	}
	if (isset($_REQUEST['splitfilternegative'])) {
		$profile->splitfilternegative = $_REQUEST['splitfilternegative'];
	}
	if (isset($_REQUEST['skipips'])) {
		$profile->skipips = $_REQUEST['skipips'];
	}
	if (isset($_REQUEST['skipfiles'])) {
		$profile->skipfiles = $_REQUEST['skipfiles'];
	}
	if (isset($_REQUEST['urlparamfilter'])) {
		$profile->urlparamfilter = $_REQUEST['urlparamfilter'];
	}
	if (isset($_REQUEST['urlparamfiltermode'])) {
		$profile->urlparamfiltermode = $_REQUEST['urlparamfiltermode'];
	}
	if (isset($_REQUEST['googleparams'])) {
		$profile->googleparams = $_REQUEST['googleparams'];
	}
}

function HandleRunningStatus($mode = 'regular') {
	global $conf, $profile, $running_from_command_line, $lang, $validUserRequired, $session, $template;
	
	if (isset($_REQUEST['reset']) && $_REQUEST['reset'] == 1) {
		setProfileData($profile->profilename, "{$profile->profilename}.update_running", "no");
	}
	
	$running = getProfileData($profile->profilename, "{$profile->profilename}.update_running", "no");
	
	if ($running == "yes") {
		# we're already running, warn usere
		if ($running_from_command_line == false) {
			include_once "top.php";
		}
		
		$button = Button("update.php?conf=$conf&amp;reset=1", "Reset Status and Continue", "color: black;");
		$out = Warning(_HANDLE__UPDATE_RUNNING_STATUS_WARNING_PART1 . " '$conf' ". _HANDLE__UPDATE_RUNNING_STATUS_WARNING_PART2 . "<br><br>$button\n\n");
		echoConsoleSafe($out, true);
		
		if ($running_from_command_line == true) {
			echo "from the console, use this to reset:\n> php update.php \"conf=$conf&reset=1\"\n";
		}
		echoConsoleSafe("</body></html>");
		exit();
	}
	
	setProfileData($profile->profilename, "{$profile->profilename}.update_running", "yes");
}


function reset_update_process(){
	global $mysqltmp,$profile;
	
	#True == reset update_running to no
	
	if(getProfileData($profile->profilename, "{$profile->profilename}.update_running", "no") == "no" ){
		return false;
	}	
	
	$log_file = "{$mysqltmp}{$profile->profilename}_lwa_log";
	if(file_exists($log_file)){
		$last_process = filemtime($log_file);	
		if((time() - $last_process) > 86400 ){
			return true;
		}
	}
	
	# Get the last action's timestamp
	$last_update_started = getProfileData($profile->profilename, $profile->profilename.".lastupdate_time", 0);
	if((time() - $last_update_started) > 86400) {
		return true;
	}	
	
	# Return false if the file is still in progress
	return false;
}

?>