<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2011 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/* this file is intended to be included in a file in the logaholic root folder */
set_time_limit(600);

$lq = "Select profileid,profilename,tablename from ".TBL_PROFILES;

// If we're limiting the visible profiles, then put a filter on to only pull those records.
if (($validUserRequired) && (!$session->isAdmin())) {
    // Can't use implode here because we need to escape the entries.
    $validprofiles = "";
    for ($i = count($session->user_profiles)-1; $i >= 0; $i--) {
        if ($validprofiles != "") { $validprofiles .= "\",\""; }
        $validprofiles .= $db->escape($session->user_profiles[$i]);
    }
    $lq .= " where profilename in (\"$validprofiles\")";
}    

$q= $db->Execute($lq);

$global_stats = array();
$daily_stats = array();
$i=0;
while ($data=$q->FetchRow()) {
    $pid = $data[0];
    $pname = $data[1];
    $tablename = $data[2];
	$profile = new SiteProfile($pname);
	
    $r = new $reports["_VISITORS_PER_MONTH"]["ClassName"]();
	$r->label = _VISITORS_PER_MONTH;
	$r->from = LogaholicFirstTimestamp();
	
	$r->to = time();
	$d = $r->GetReportData();
	
	$visitors = 0;
	$pageviews = 0;	
	
	if(!empty($d)){	
		foreach($d as $dataset){
			$visitors = $visitors + $dataset[1];
			$pageviews = $pageviews + $dataset[2];
		}		
		$global_stats[$i][5] = date('Y-m-d',$r->from);
		$global_stats[$i][6] = date('Y-m-d',$r->to);
	} else {
		$global_stats[$i][5] = "0000-00-00";
		$global_stats[$i][6] = "0000-00-00";
	}	
	$global_stats[$i][0] = "<a title='"._CLICK_TO_PROFILE_MAINTENANCE."' href='profiles.php?editconf={$pname}&del=1'>{$pname}</a>";
    $global_stats[$i][1] = $visitors; # visitors
	$global_stats[$i][2] = $pageviews; # pageviews
	
	$range = $r->to - $r->from;
	$days = round($range / 86400);
	if($days < 1){ $days = 1; }
	
	$global_stats[$i][3] = ($visitors == 0) ? 0 : ($visitors / $days) ; # visitors avg p d
	$global_stats[$i][4] = ($pageviews == 0) ? 0 : ($pageviews / $days) ; # pageviews avg p d
	
	ksort($global_stats[$i]);    
    $i++;   
}

$reportClass = new DataVisualization();

echo "<div id='content' style='width:1024px;'>";
	echo "<div class='dialog'>";
		echo "<div class='dialog-header'><label class=\"dialog-label\" rel=\"_ALL_TIME_ALL_PROFILES\">"._ALL_TIME_ALL_PROFILES."</label></div>";
		echo "<div class='dialog-content'>";
			$reportClass->label=_ALL_TIME_ALL_PROFILES;
			$reportClass->help=_ALL_TIME_ALL_PROFILES_HELP;
			$reportClass->from=0;
			$reportClass->to=time();
			$reportClass->columnDefinitions[] = array("Label" => _PROFILENAME, "totalRow" => "none");
			$reportClass->columnDefinitions[] = array("Label" => _UNIQUE_VISITORS, "totalRow" => "none");
			$reportClass->columnDefinitions[] = array("Label" => _PAGEVIEWS, "totalRow" => "none");
			$reportClass->columnDefinitions[] = array("Label" => "Avg. Visitors per day", "bchart" => true, "totalRow" => "none");
			$reportClass->columnDefinitions[] = array("Label" => "Avg. Pageviews per day", "bchart" => true, "totalRow" => "none");
			$reportClass->columnDefinitions[] = array("Label" => _FROM, "totalRow" => "none");
			$reportClass->columnDefinitions[] = array("Label" => _DATE_TO,"totalRow" => "none");
			$reportClass->setupColumnDefinitions();

			$data = DataSort($global_stats,1);
			$reportClass->Table($data);
		echo "</div>";
	echo "</div>";
	echo "<hr noshade size=1 style=\"margin-top:25px;margin-bottom:25px;\">";
echo "</div>";
?>

