<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2011 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc This report displays all traffic by day
*/
$reports["_ALL_TRAFFIC_BY_DAY"] = Array(
	"ClassName" => "AllTrafficByDay", 
	"Category" => "_TRAFFIC", 
	"icon" => "images/icons/32x32/alltrafficbyday.png",
	"Options" => "daterangeField,profileselector,trafficsource,columnSelector",
	"Filename" => "all_traffic_by_day",
	"Distribution" => "Standard",
	"Order" => 4,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => true
);

class AllTrafficByDay extends Report {
	
	function Settings() {
		$this->columnDefinitions[] = array("Label" => _DATE);
		$this->columnDefinitions[] = array("Label" => _UNIQUE_VISITORS);
		$this->columnDefinitions[] = array("Label" => _TOTAL_PAGES);
		$this->columnDefinitions[] = array("Label" => _VIEWED_PAGES, "bchart" => false);
		$this->columnDefinitions[] = array("Label" => _CRAWLED_PERC);
		$this->columnDefinitions[] = array("Label" => _VISITS, "bchart" => false);
		$this->columnDefinitions[] = array("Label" => _PAGES_PER_VISIT);
		
		$this->help = _ALL_TRAFFIC_BY_DAY_DESC;
		$this->sort = false;
	}
	function GetReportData(){
		global $db, $get_constant;
		$this->createDataFiles($this->from,$this->to);
		$d = $this->getDataFromFiles($this->dataFiles($this->from,$this->to));	
		$data = array();
		$i = 0;
		foreach($d as $val){
			$data[$i][0]  = $val[0];
			$data[$i][1]  = $val[5];
			$data[$i][2]  = $val[2];
			$data[$i][3]  = $val[3];
			$data[$i][4]  = ($val[4] / $val[2]) * 100;
			$data[$i][5]  = $val[1];
			$data[$i][6]  = $val[2] / $val[1];
			$i ++;
		}		
		return $data;
	}
	function DefineQuery() {
		$query = "SELECT FROM_UNIXTIME(timestamp, '%d-%b-%Y %a') AS days, COUNT(distinct sessionid) as visits, COUNT(*) as requests, (COUNT(*) - SUM(crawl)) AS viewed, SUM(crawl) AS crawled, COUNT(distinct visitorid) as visitors FROM ".$this->profile->MainCrawlMerge()." WHERE timestamp >= {$this->from} AND timestamp <= {$this->to} GROUP BY days ORDER BY timestamp";

		return $query;
	}
}
?>