<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2011 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc Definitions for this report:

    Visitors: Unique Visitors that accessed your site (excluding any bots and crawlers).
    Pageviews: The total number of pages requested (excluding any bots and crawlers).
    Average Pages per user: The total number of pages devided by the number of visitors.

Tip: Make sure you set a proper date range (e.g. start from the first day of a month).
*/
$reports["_VISITORS_PER_MONTH"] = Array(
	"ClassName" => "VisitorsPerMonth", 
	"Category" => "_VISITOR_DETAILS", 
	"icon" => "images/icons/32x32/visitorspermonth.png",
	"Options" => "daterangeField,profileselector,displaymode,trafficsource,columnSelector",
	"Filename" => "visitors_per_month",
	"Distribution" => "Standard",
	"Order" => 5,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => true
);

class VisitorsPerMonth extends Report {
	
	function Settings() {	
		$this->DisplayModes = "table,linechart,barchart";
		$this->DefaultDisplay = "table";
		if(empty($this->displaymode)){
			$this->displaymode = $this->DefaultDisplay;
		}
		
		$this->columnDefinitions[] = array("Label" => "_DATE");
		$this->columnDefinitions[] = array("Label" => "_UNIQUE_VISITORS");
		$this->columnDefinitions[] = array("Label" => "_PAGEVIEWS");
		$this->columnDefinitions[] = array("Label" => "_PAGES_PER_USER", "totalRow" => "avg");
		
		if($this->displaymode !== 'table'){
			$this->columnDefinitions[] = Array("Label" => "_VISITS", "display" => false);
		}
		
		$this->allowDateFormat = false;
		$this->ignoreDayFileCreation = true;
		$this->sort = false;

	}
	function dataFiles($from,$to) {
		global $get_constant;
		$files = array();
		$time = $from;
		
		while($time <= $to) {
			$path = "{$this->profile->datamanagerDir}{$this->profile->profilename}/reports/".date("Y",$time)."/{$get_constant[$this->label]}";
			
			$lastday = get_month_lastday(date("m",$time),date("Y",$time));
			$l_day = mktime(23,59,59,date("m",$time),$lastday ,date("Y",$time));
			
			$daterange = date("Ym",$time);
			$files[] = "$path/{$get_constant[$this->label]}.{$daterange}{$this->fileNameExpension}.gz";
					
			$time= $l_day + 1;
		}
		return $files;		
	}
	function DefineQuery() {
		$query = "SELECT FROM_UNIXTIME(timestamp, '%M %Y') AS month, COUNT(DISTINCT visitorid) as visitors, COUNT(*) as pages, (COUNT(*) / COUNT(DISTINCT visitorid)) AS ppu, COUNT(DISTINCT sessionid) as visits FROM {$this->profile->tablename} WHERE timestamp >= {$this->from} AND timestamp <= {$this->to} GROUP BY month ORDER BY timestamp";

		return $query;
	}
}
?>
