<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2011 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 

// include_once("components/useragents/techpattern.php");

function ExpireDataFiles(){
	global $profile;
	
	$flagged = getProfileData($profile->profilename, "{$profile->profilename}.IncompleteDatafiles", serialize(array()));
	$flagged = unserialize($flagged);
	foreach($flagged as $k => $v){		
		if(file_exists($v)){
			if(unlink($v)){
				unset($flagged[$k]);
			} else {
				echoConsoleSafe("Unable to remove file: {$v}",true);
			}
		} else {
			unset($flagged[$k]);
		}
	}
	$flagged = serialize($flagged);
	setProfileData($profile->profilename, "{$profile->profilename}.IncompleteDatafiles", $flagged);
}

function GetTopReports(){
	global $db,$profile;
	
	# Get the top 10 reports
	$query = "SELECT reporturl, SUM(hits) AS pop FROM ".TBL_REPORT_USAGE." WHERE profilename = '{$profile->profilename}' AND reporturl NOT LIKE '%_VISITORS_PER_DAY%' AND reporturl NOT LIKE '%_VISITORS_PER_MONTH%' GROUP BY reporturl ORDER BY pop DESC LIMIT 10";
	$q = $db->Execute($query);
	
	# Build an array for each report we should create data files for.
	$createDataFilesForReports = array();
	
	while($reportdata = $q->FetchRow()) {
		# Put all options in the array we just defined.
		$reportoptions = $reportdata['reporturl'];
		parse_str($reportoptions, $reportoptions_array); # This makes an array out of a query string
		
		$tmp_data = array();
		
		foreach($reportoptions_array as $key => $val) {
			if($key == 'labels') {
				$reportlabel = $val;
			}
			$tmp_data[$key] = $val;
		}
		
		$createDataFilesForReports[$reportlabel] = $tmp_data;
	}
	return $createDataFilesForReports;
}

function GetCorrectFromDate($table) {
    //we need to make protection against holes in the summary tables if update.php has failed halfway
    // so, we should always update from the last record in the table, and set 'from' based on that
    global $db, $profile, $orist, $first_ever_time, $force;
    //echoConsoleSafe("<script>pstatus('"._CHECKING_TABLE." $table ...                                                            ')</script>\n");
    lgflush();

    if ($force==true && isset($first_ever_time)) {
        return mktime(0,0,0,date("m",$first_ever_time),date("d",$first_ever_time),date("Y",$first_ever_time)); 
    } 
    
    $q = $db->Execute("select * from $table order by timestamp desc limit 1");
    if ($data=$q->FetchRow()) {
       /* 
       echo "<br>the last record in $table is timestamp ". $data['timestamp'] . ", and orist is $orist,";
        if (date("Y-m-d",$data['timestamp'])==date("Y-m-d",$orist)) {
            echo " that is the same day (".date("Y-m-d H:i:s",$data['timestamp']).") so our data is integer";
        } else {
            echo " that is NOT the same day (orist: ".date("Y-m-d H:i:s",$orist).", database: ".date("Y-m-d H:i:s",$data['timestamp']).", ) so our data is wrong!!";
        }
        echo "<P>";
        */
        return mktime(0,0,0,date("m",$data['timestamp']),date("d",$data['timestamp']),date("Y",$data['timestamp']));
    } else {
        return 0; // if no data, try to fill the table from the start
    }      
}

ob_start(); 
//echoConsoleSafe("<script>pstatus('"._SUMMARIES."...                                                                       ')</script>\n");
lgflush();

if (@$force==true && isset($last_inserted_time)) {
    $from = mktime(0,0,0,date("m",$first_ever_time),date("d",$first_ever_time),date("Y",$first_ever_time));
    $to = mktime(23,59,59,date("m",$last_inserted_time),date("d",$last_inserted_time),date("Y",$last_inserted_time));
    echoConsoleSafe(_FORCED_UPDATE_RECALCING_SUMMARIES." ".date("Y-m-d H:i:s",$from)." to ".date("Y-m-d H:i:s",$to), true);
} else {
    $to = mktime(23,59,59,date("m"),date("d"),date("Y"));
}

 
if (@$force==true && isset($last_inserted_time)) {
    $to = mktime(23,59,59,date("m",$last_inserted_time),date("d",$last_inserted_time),date("Y",$last_inserted_time));  
}

$todaysdate=time();

# We have just update so expire most recent datafiles
ExpireDataFiles();

# Get the usage data for the current profile
$profileFrequency = getProfileData($profile->profilename, "{$profile->profilename}.usage", serialize(array()));
$profileFrequency = unserialize($profileFrequency);

# Create an array of timestamps from the data we fetched above
$fq_array = array();
foreach($profileFrequency as $pfq) {
	$time = strtotime(substr($pfq, 0, 4)."-".substr($pfq, 4, 2)."-".substr($pfq, 6, 2));
	$time = mktime(0, 0, 0, date('m', $time), date('d', $time), date('Y', $time));
	$fq_array[] = $time;
}

# Add today to the diff array
$fq_array[] = mktime(0, 0, 0, date('m', time()), date('d', time()), date('Y', time()));

# Create an array with the differences between each value
$frequency_diffs = array();
$previous = 0;
foreach($fq_array as $pfq) {
	if($previous != 0) {
		$frequency_diffs[] = ($pfq - $previous) / 86400;
	}
	
	$previous = $pfq;
}

if(count($frequency_diffs) <= 1) {
	$frequency = 30;
} else {
	$frequency = (array_sum($frequency_diffs) / count($frequency_diffs));
}

# If there has been no update before, set the last update time to zero, so we always create data files.
$last_update_time = getProfileData($profile->profilename, "{$profile->profilename}.lastUpdateTime", 0);
$last_report_update = getProfileData($profile->profilename, "{$profile->profilename}.lastReportUpdate", 0);

$days_since_update = floor((time() - $last_report_update) / 86400);
if($days_since_update >= $frequency) {
	# Add today to the profile usage array and save it
	$profileFrequency[] = date('Ymd');
	setProfileData($profile->profilename, "{$profile->profilename}.lastReportUpdate", time());
	setProfileData($profile->profilename, "{$profile->profilename}.usage", serialize($profileFrequency));
	
	$createDataFilesForReports = GetTopReports();
	
	if (!isset($ignoreReports) || $ignoreReports !== 1) {
		foreach($reports as $k => $v){
			$r = new $reports[$k]["ClassName"]();
			if($v['Distribution'] == 'Unlisted') {
				continue;
			}
			
			if(isset($reports[$k]["Update"]) && $reports[$k]["Update"] == false) {
				continue;
			}
			
			$r->label = constant($k);
			
			if($r->UpdateStats()) {
				//echoConsoleSafe("<script>pstatus('Updated $k...')</script>");
			}
			
			if(array_key_exists($k, $createDataFilesForReports) == true) { # We should create data files
				# Apply each option to the report class
				foreach($createDataFilesForReports[$k] as $optionname => $optionvalue) {
					$r->$optionname = $optionvalue;
				}
				
				if(!isset($first_ever_time)){
					$first_ever_time= $r->dbMinimumDate;
				}
				if(!isset($last_inserted_time)){
					$last_inserted_time = $r->dbMaximumDate;
				}
				
				# Create the data files
				$r->createDataFiles(mktime(0, 0, 0, date('m', $first_ever_time), date('d', $first_ever_time), date('Y', $first_ever_time)), mktime(23, 59, 59, date("m", $last_inserted_time), date("d", $last_inserted_time), date("Y", $last_inserted_time)),2);
			}
		}
	}
} else {
	# We should not create data files
	$createDataFilesForReports = array();
}

$first_time_ever_updated = getProfileData($profile->profilename, "{$profile->profilename}.firstRequestTimeEver", false);
if($first_time_ever_updated == false) {
	$q = $db->Execute("SELECT MIN(`timestamp`) as mintime FROM {$profile->tablename} LIMIT 1");
	$firstTime = '';
	$firstTime = $q->fetchRow();
	$firstTime = $firstTime['mintime'];
	if(!empty($firstTime)){
		setProfileData($profile->profilename, "{$profile->profilename}.firstRequestTimeEver", $firstTime);
	}
}

if(empty($last_inserted_time)){
	$last_inserted_time = time();
}

setProfileData($profile->profilename, "{$profile->profilename}.lastUpdateTime", $last_inserted_time);


# now it's time to check if we need to send any email alerts
include "includes/emailalerts.php";
$e = new EmailAlerts();
$sent = count($e->SendAlerts());
if ($sent > 0) {
    echoConsoleSafe("\n\n<br>".str_replace('%a',$sent,_SENT_X_ALERTS)."<br>",true);
}
//echoConsoleSafe("<script type='text/javascript'>pstatus('"._FINISHED."')</script>");


//echoConsoleSafe("<script>pstatus('"._FINISHED_UPDATE."')</script>");
//echoConsoleSafe("<script>pbar(100); self.document.forms.progress.progbar.value='||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||';</script>");
lgflush();
?>